# Makefile for VisualC++6.0
#
# macro

APP	=	X88000

SRCDIR	=	.
DSTDIR	=	Release_VC6

CC	=	cl.exe
CFLAGS	=	/nologo /MT /GR /GX /O2 \
		/D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" \
		/Fo"$(DSTDIR)\\" /Fd"$(DSTDIR)\\" /FD

RCC	=	rc.exe
RFLAGS	=	/l 0x411 /d "NDEBUG"

LNK	=	link.exe
LFLAGS	=	/nologo /subsystem:windows /incremental:no /machine:I386

RC	=	$(SRCDIR)\$(APP).rc
EXE	=	$(DSTDIR)\$(APP).exe
RES	=	$(DSTDIR)\$(APP).res
OBJS	=	$(DSTDIR)\DiskImage.obj \
		$(DSTDIR)\DiskImageCollection.obj \
		$(DSTDIR)\DiskImageFile.obj \
		$(DSTDIR)\InitGuid.obj \
		$(DSTDIR)\ParallelDevice.obj \
		$(DSTDIR)\ParallelNull.obj \
		$(DSTDIR)\ParallelPR201.obj \
		$(DSTDIR)\ParallelPrinter.obj \
		$(DSTDIR)\PC88.obj \
		$(DSTDIR)\PC88Calendar.obj \
		$(DSTDIR)\PC88Crtc.obj \
		$(DSTDIR)\PC88Fdc.obj \
		$(DSTDIR)\PC88Opna.obj \
		$(DSTDIR)\PC88Pcg.obj \
		$(DSTDIR)\PC88Ppi.obj \
		$(DSTDIR)\PC88Timer.obj \
		$(DSTDIR)\PC88Usart.obj \
		$(DSTDIR)\PC88Z80Main.obj \
		$(DSTDIR)\PC88Z80Sub.obj \
		$(DSTDIR)\StdHeader.obj \
		$(DSTDIR)\TapeImage.obj \
		$(DSTDIR)\X88000.obj \
		$(DSTDIR)\X88BeepPlayer.obj \
		$(DSTDIR)\X88DebugBreakPointDlg.obj \
		$(DSTDIR)\X88DebugDisAssembleDlg.obj \
		$(DSTDIR)\X88DebugDumpDlg.obj \
		$(DSTDIR)\X88DebugWnd.obj \
		$(DSTDIR)\X88DebugWriteRamDlg.obj \
		$(DSTDIR)\X88Dialog.obj \
		$(DSTDIR)\X88DirectX.obj \
		$(DSTDIR)\X88DiskImageDlg.obj \
		$(DSTDIR)\X88DiskImageMemory.obj \
		$(DSTDIR)\X88EnvSetDlg.obj \
		$(DSTDIR)\X88FileDlg.obj \
		$(DSTDIR)\X88Frame.obj \
		$(DSTDIR)\X88Option.obj \
		$(DSTDIR)\X88ParallelManager.obj \
		$(DSTDIR)\X88PrinterCopyDlg.obj \
		$(DSTDIR)\X88PrinterDlg.obj \
		$(DSTDIR)\X88PrinterDrawer.obj \
		$(DSTDIR)\X88PrinterPaperDelDlg.obj \
		$(DSTDIR)\X88PrinterPaperFeedDlg.obj \
		$(DSTDIR)\X88PrinterPreviewWnd.obj \
		$(DSTDIR)\X88Resource.obj \
		$(DSTDIR)\X88ScreenDrawer.obj \
		$(DSTDIR)\X88TapeImageDlg.obj \
		$(DSTDIR)\X88Utility.obj \
		$(DSTDIR)\X88VersionDlg.obj \
		$(DSTDIR)\X88View.obj \
		$(DSTDIR)\Z80.obj \
		$(DSTDIR)\Z80Adapter.obj \
		$(DSTDIR)\Z80Data.obj \
		$(DSTDIR)\Z80_2.obj
DSTDIRX	=	$(DSTDIR)\NUL
LIBS	=	kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib \
		advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib \
		odbc32.lib odbccp32.lib comctl32.lib version.lib imm32.lib \
		winmm.lib dinput.lib

# rule

all:	$(DSTDIR) $(EXE)

clean:
	del $(DSTDIR)\*.obj
	del $(DSTDIR)\*.res
	del $(DSTDIR)\*.exe
	del $(DSTDIR)\*.idb

$(DSTDIR):
	if not exist $(DSTDIRX) mkdir $(DSTDIR)

$(EXE): $(OBJS) $(RES)
	$(LNK) $(LFLAGS) /out:$(EXE) $(OBJS) $(RES) $(LIBS)

$(RES):	$(RC)
	$(RCC) $(RFLAGS) /fo$(RES) $(RC)

{$(SRCDIR)}.cpp{$(DSTDIR)}.obj::
	$(CC) $(CFLAGS) /c $<
